SYS0/A VALUE	LD	IX,TYPSAV
 	JP	VDECI		;DEFAULT VALUE
 ;	SYS0/ASM
 VALPOS	LD	A,(HL)		;GET A BYTE
 	CP	'&'		;NUMBER TYPE CHANGE ?
 	JP	Z,VCHANGE	;CHANGE IT
 	CALL	IFNUM		;CHECK IF NUMERIC
 	JR	NC,DECCON	;NUMERIC IF NC
 	CP	';'
 	JP	Z,VALCOM
 	CP	','
 	JP	Z,VALCOM
 	CP	21H
 	JP	C,VALCOM
 	JP	VALBAD
 DECCON	INC	HL		;BUMP POINTER
 	INC	B		;BUMP LENGTH
 	JR	VALPOS		;CONTINUE THROUGH STRING
 TYPSAV	DW	0		;TOP OF NUMERIC SAVE
 VCHANGE	INC	HL
 	LD	A,(HL)		;GET SPECIFIER
 	INC	HL		;POINT TO DATA
 	RES	5,A		;LOWER CASE OFF
 	CP	'H'		;HEX ?
 	JP	Z,VHEXI
 	CP	'D'
 	JP	Z,VDECI
 	CP	'B'
 	JP	Z,VBINI
 	CP	'O'
 	JP	Z,VOCTAL
 	SCF
 	RET			;RETURN IN ERROR
 VALBAD	LD	HL,(DATPNT)	;RESTORE HL POINTER
 VABAD	SCF			;CARRY = BAD
 	RET			;DONE
 VALPOSOD	SCF			;CLEAR CARRY
 	CCF
 	RET
 IFNUM	CP	30H		;CHECK FOR 0-9
 	JR	C,VABAD
 	CP	3AH
 	JR	C,VALPOSOD
 	CP	41H		;CHECK FOR A-F
 	JR	C,VABAD
 	RES	5,A
 	CP	47H
 	JR	NC,VABAD
 	JR	VALPOSOD
 VDECI	LD	(IX),10
 	LD	(IX+1),6
 VALGO	LD	(DATPNT),HL	;NEW DATA POINTER
 	LD	B,0		;INITIALIZE LENGTH
 	JP	VALPOS		;CONTINUE
 VHEXI	LD	(IX),16
 	LD	(IX+1),5
 	JR	VALGO
 VBINI	LD	(IX),2
 	LD	(IX+1),9
 	JR	VALGO
 VOCTAL	LD	(IX),8
 	LD	(IX+1),4
 	JR	VALGO
 VALCOM	LD	A,B		;GET LENGTH
 	OR	A		;TEST FOR ZERO LENGTH
 	JP	Z,VALBAD
 	CP	(IX+1)		;TEST FOR MAX LENGTH
 	JR	Z,VCOK		;FINISHED
 	JP	NC,VALBAD
 	LD	HL,(DATPNT)	;GET DATA POINTER BACK
 VALCOM2	LD	A,B		;GET LENGTH
 	CP	(IX+1)		;AT MAX ?
 	JR	Z,VCOK		;CONTINUE IF YES
 	DEC	HL		;REDUCE POINTER
 	LD	(HL),'0'	;ZERO IT
 	INC	B		;BUMP LENGTH
 	JR	VALCOM2
 VCOK	LD	DE,0		;START WITH 0
 	DEC	(IX+1)		;ONE LESS THAN MAX
 VCOKLP	LD	A,(HL)		;GET BYTE FROM STRING
 	CALL	MAKNUM		;MAKE NUMERIC
 	CP	(IX)		;COMPARE TO MAX DIGIT
 	JP	NC,VALBAD	;BAD IF TOO BIG
 	PUSH	HL		;SAVE FOR CONVERSION
 	LD	L,A
 	LD	H,0		;HL=NUMBER
 	PUSH	DE		;SAVE TOTAL
 	LD	B,(IX+1)	;# OF LOOPS
 VALHRR	PUSH	BC		;SAVE FROM MULT
 	CALL	MULT		;MULTIPLY
 	POP	BC		;RESTORE COUNT
 	DJNZ	VALHRR		;SO MANY TIMES
 	POP	DE		;RESTORE TOTAL
 	ADD	HL,DE		;ADD TO TOTAL
 	EX	DE,HL		;DE=TOTAL
 	POP	HL		;RESTORE POINTER
 	INC	HL		;BUMP POINTER
 	DEC	(IX+1)		;LESS ONE FOR COUNT
 	JR	NZ,VCOKLP	;GO TO LOOP
 	LD	A,(HL)		;GET FINAL BYTE
 	CALL	MAKNUM		;MAKE IT BINARY
 	PUSH	HL		;SAVE POINTER
 	LD	L,A
 	LD	H,0		;HL=LAST NUMBER
 	ADD	HL,DE		;ADD ONE
 	EX	DE,HL		;DE=TOTAL
 	POP	HL		;RESTORE IT
 	INC	HL		;BUMP POINTER
 	LD	A,D		;SET FLAGS FOR VALUE
 	OR	A
 	PUSH	DE
 	POP	BC		;PASS TO BC
 	SCF
 	CCF			;CLEAR CARRRY FLAG
 	RET
 MAKNUM	SUB	30H		;REMOVE ASCII
 	CP	0AH		;IS IT 0-9
 	RET	C
 	SUB	7
 	CP	17
 	RET	C
 	SUB	20H		;REMOVE LOWER CASE
 	RET			;ADJUST FOR A-F
 MULT	EX	DE,HL		;DE=NUMBER TO MULT
 	LD	HL,0		;START WITH 0
 	LD	B,(IX)		;GET MULTIPLIER
 MULTLP	SRL	B		;SHIFT OUT MULTIPLIER
 	JR	NC,MULTCON	;GO IF NO CARRY (EVEN)
 	ADD	HL,DE		;ADD MULTIPLICAND
 MULTCON	RET	Z		;GO IF MULTIPLIER
 	EX	DE,HL		;MULTIPLICAND TO HL
 	ADD	HL,HL		;DOUBLE IT FOR EVEN
 	EX	DE,HL		;SWAP BACK
 	JR	MULTLP		;CONTINUE
 FIXDRV	SUB	30H		;REMOVE ASCII
 	JR	C,DRVBAD	;BAD DRIVE IF LESS THAN 0
 	CP	8		;UP TO 8 DRIVES
 	JR	NC,DRVBAD	;0-7 ONLY
 	LD	(DRIVE),A	;SAVE BINARY DRIVE
 	PUSH	BC		;SAVE IT
 	LD	B,1		;START WITH DRIVE 1
 DRVLP	OR	A		;SET FLAGS
 	JR	Z,DRVFND	;DRIVE FOUND
 	DEC	A		;REDUCE DRIVE BINARY
 	SLA	B		;SHIFT DRIVE BIT IN B
 	JR	DRVLP		;CONTINUE
 DRVFND	LD	A,B		;GET BIT PATTERN
 	POP	BC		;RESTORE BC
 	LD	(DRIV),A	;SET BIT FOR DRIVE SELECT
 	OR	A		;CLEAR CARRY
 	RET
 DRVBAD	SCF			;CARRY = BAD DRIVE
 DRVASC	PUSH	BC		;SAVE BC
 	LD	B,30H		;START WITH 0
 DRVALP	RRCA			;SHIFT BIT FROM DRIVE
 	JR	C,DRVAFND	;FOUND IT
 	INC	B		;BUMP ASCII
 	JR	DRVALP		;CONTINUE
 DRVAFND	LD	A,B		;GET ASCII
 	POP	BC		;RESTORE BC
 	RET
 ASCII	PUSH	HL		;SAVE IT
 	CALL	ASCI		;CONVERT
 	LD	H,B		;SAVE HIGH TO H
 	PUSH	HL		;SAVE ON STACK
 	LD	A,C		;GET NEXT MSB
 	SUB	30H		;REMOVE ASCII
 	CALL	ASCI		;MAKE THAT ASCII
 	LD	A,C		;A=MSB
 	POP	HL		;LAST OPERATION
 	LD	C,B		;NEW MIDDLE DIGIT
 	LD	B,H		;NEW LOW DIGIT
 	POP	HL		;RESTORE HL
 	RET			;DONE
 ASCI	LD	C,30H		;START WITH 0
 ASCII1	SUB	0AH		;MINUS 10
 	JR	C,ASCII2	;0-9
 	INC	C		;>9
 	JR	ASCII1
 ASCII2	ADD	A,3AH		;MAKE CARRY ASCII
 	LD	B,A		;GIVE TO B
 	RET			;DONE
 HEXCV	PUSH	HL		;SAVE HL
 	LD	C,A		;SAVE HERE
 	SRL	A		;ALIGN HIGH NIBBLE
 	SRL	A
 	SRL	A
 	SRL	A
 	CALL	HEXTST		;ADJUST TO ASCII
 	LD	L,A		;SAVE IT HERE
 	LD	A,C		;GET ORIGINAL NUMBER BACK
 	AND	0FH		;ALIGN LOW NIBBLE
 	CALL	HEXTST		;ADJUST TO HEX ASCII
 	LD	B,A		;GIVE TO B
 	LD	C,L		;HIGH DIGIT
 	POP	HL		;RESTORE IT
 	RET			;BC=ASCII HEX
 HEXTST	ADD	A,30H		;CONVERSION FACTOR
 	CP	3AH		;IF 0-9
 	RET	M		;OK NOW
 	ADD	A,7		;ADJUST FOR A-F
 	RET			;OK NOW
 	END
 	LD	B,A		;GIVE TO B
 	LD	C,